//---------------------------------------------------------------------------
#ifndef memoryH
#define memoryH

#include	"defs.h"

class Memory
	{
public:
    virtual char * Pointer2Line(long handle, unsigned int pos)=0;
    long	DevelopMail(FILE * output, char * =NULL);
    virtual     ~Memory();
    };

class MemoryFromFile : public Memory
	{
    char 			*p;
    int				size;
    int				length;
    long			position;

    int				fd;
public:

    void			Read(long pos);
    char *			Pointer2Line(long handle, unsigned int pos);
    void			Open(char * path);
    void			Close();
    MemoryFromFile(unsigned int maxsize, unsigned int minsize);
    ~MemoryFromFile();
    };

class MemoryFromMemory : public Memory
	{
        long	handle;
        char	boundary[LINE_SIZE];
        int	strlenofboundary;
        Memory * parent;

public:
    char * Pointer2Line(long handle, unsigned int pos);
    MemoryFromMemory(long hnd, char * bound, Memory * prnt);
    ~MemoryFromMemory();
    };

//---------------------------------------------------------------------------
#endif
